package hu.bme.mit.train.constraintcheck.incquery;

import hu.bme.mit.train.constraintcheck.incquery.Ase_aMatcher;
import hu.bme.mit.train.constraintcheck.incquery.util.Ase_aQuerySpecification;
import org.eclipse.incquery.runtime.api.IncQueryEngine;
import org.eclipse.incquery.runtime.api.impl.BaseGeneratedPatternGroup;
import org.eclipse.incquery.runtime.exception.IncQueryException;

/**
 * A pattern group formed of all patterns defined in ase_a.eiq.
 * 
 * <p>Use the static instance as any {@link org.eclipse.incquery.runtime.api.IPatternGroup}, to conveniently prepare
 * an EMF-IncQuery engine for matching all patterns originally defined in file ase_a.eiq,
 * in order to achieve better performance than one-by-one on-demand matcher initialization.
 * 
 * <p> From package hu.bme.mit.train.constraintcheck.incquery, the group contains the definition of the following patterns: <ul>
 * <li>ase_a</li>
 * </ul>
 * 
 * @see IPatternGroup
 * 
 */
@SuppressWarnings("all")
public final class Ase_a extends BaseGeneratedPatternGroup {
  /**
   * Access the pattern group.
   * 
   * @return the singleton instance of the group
   * @throws IncQueryException if there was an error loading the generated code of pattern specifications
   * 
   */
  public static Ase_a instance() throws IncQueryException {
    if (INSTANCE == null) {
    	INSTANCE = new Ase_a();
    }
    return INSTANCE;
    
  }
  
  private static Ase_a INSTANCE;
  
  private Ase_a() throws IncQueryException {
    querySpecifications.add(Ase_aQuerySpecification.instance());
    
  }
  
  public Ase_aQuerySpecification getAse_a() throws IncQueryException {
    return Ase_aQuerySpecification.instance();
  }
  
  public Ase_aMatcher getAse_a(final IncQueryEngine engine) throws IncQueryException {
    return Ase_aMatcher.on(engine);
  }
}
