package hu.bme.mit.train.constraintcheck.incquery;

import hu.bme.mit.train.constraintcheck.incquery.Ase_cMatcher;
import hu.bme.mit.train.constraintcheck.incquery.util.Ase_cQuerySpecification;
import org.eclipse.incquery.runtime.api.IncQueryEngine;
import org.eclipse.incquery.runtime.api.impl.BaseGeneratedPatternGroup;
import org.eclipse.incquery.runtime.exception.IncQueryException;

/**
 * A pattern group formed of all patterns defined in ase_c.eiq.
 * 
 * <p>Use the static instance as any {@link org.eclipse.incquery.runtime.api.IPatternGroup}, to conveniently prepare
 * an EMF-IncQuery engine for matching all patterns originally defined in file ase_c.eiq,
 * in order to achieve better performance than one-by-one on-demand matcher initialization.
 * 
 * <p> From package hu.bme.mit.train.constraintcheck.incquery, the group contains the definition of the following patterns: <ul>
 * <li>ase_c</li>
 * </ul>
 * 
 * @see IPatternGroup
 * 
 */
@SuppressWarnings("all")
public final class Ase_c extends BaseGeneratedPatternGroup {
  /**
   * Access the pattern group.
   * 
   * @return the singleton instance of the group
   * @throws IncQueryException if there was an error loading the generated code of pattern specifications
   * 
   */
  public static Ase_c instance() throws IncQueryException {
    if (INSTANCE == null) {
    	INSTANCE = new Ase_c();
    }
    return INSTANCE;
    
  }
  
  private static Ase_c INSTANCE;
  
  private Ase_c() throws IncQueryException {
    querySpecifications.add(Ase_cQuerySpecification.instance());
    
  }
  
  public Ase_cQuerySpecification getAse_c() throws IncQueryException {
    return Ase_cQuerySpecification.instance();
  }
  
  public Ase_cMatcher getAse_c(final IncQueryEngine engine) throws IncQueryException {
    return Ase_cMatcher.on(engine);
  }
}
