package hu.bme.mit.train.constraintcheck.incquery;

import hu.bme.mit.train.constraintcheck.incquery.Ase_dMatcher;
import hu.bme.mit.train.constraintcheck.incquery.util.Ase_dQuerySpecification;
import org.eclipse.incquery.runtime.api.IncQueryEngine;
import org.eclipse.incquery.runtime.api.impl.BaseGeneratedPatternGroup;
import org.eclipse.incquery.runtime.exception.IncQueryException;

/**
 * A pattern group formed of all patterns defined in ase_d.eiq.
 * 
 * <p>Use the static instance as any {@link org.eclipse.incquery.runtime.api.IPatternGroup}, to conveniently prepare
 * an EMF-IncQuery engine for matching all patterns originally defined in file ase_d.eiq,
 * in order to achieve better performance than one-by-one on-demand matcher initialization.
 * 
 * <p> From package hu.bme.mit.train.constraintcheck.incquery, the group contains the definition of the following patterns: <ul>
 * <li>ase_d</li>
 * </ul>
 * 
 * @see IPatternGroup
 * 
 */
@SuppressWarnings("all")
public final class Ase_d extends BaseGeneratedPatternGroup {
  /**
   * Access the pattern group.
   * 
   * @return the singleton instance of the group
   * @throws IncQueryException if there was an error loading the generated code of pattern specifications
   * 
   */
  public static Ase_d instance() throws IncQueryException {
    if (INSTANCE == null) {
    	INSTANCE = new Ase_d();
    }
    return INSTANCE;
    
  }
  
  private static Ase_d INSTANCE;
  
  private Ase_d() throws IncQueryException {
    querySpecifications.add(Ase_dQuerySpecification.instance());
    
  }
  
  public Ase_dQuerySpecification getAse_d() throws IncQueryException {
    return Ase_dQuerySpecification.instance();
  }
  
  public Ase_dMatcher getAse_d(final IncQueryEngine engine) throws IncQueryException {
    return Ase_dMatcher.on(engine);
  }
}
