package hu.bme.mit.train.constraintcheck.incquery;

import Concept.Segment;
import hu.bme.mit.train.constraintcheck.incquery.util.Ase_locals_3QuerySpecification;
import java.util.Arrays;
import java.util.List;
import org.eclipse.incquery.runtime.api.IPatternMatch;
import org.eclipse.incquery.runtime.api.impl.BasePatternMatch;
import org.eclipse.incquery.runtime.exception.IncQueryException;

/**
 * Pattern-specific match representation of the hu.bme.mit.train.constraintcheck.incquery.ase_locals_3 pattern,
 * to be used in conjunction with {@link Ase_locals_3Matcher}.
 * 
 * <p>Class fields correspond to parameters of the pattern. Fields with value null are considered unassigned.
 * Each instance is a (possibly partial) substitution of pattern parameters,
 * usable to represent a match of the pattern in the result of a query,
 * or to specify the bound (fixed) input parameters when issuing a query.
 * 
 * @see Ase_locals_3Matcher
 * @see Ase_locals_3Processor
 * 
 */
@SuppressWarnings("all")
public abstract class Ase_locals_3Match extends BasePatternMatch {
  private Segment fSeg1;
  
  private static List<String> parameterNames = makeImmutableList("Seg1");
  
  private Ase_locals_3Match(final Segment pSeg1) {
    this.fSeg1 = pSeg1;
    
  }
  
  @Override
  public Object get(final String parameterName) {
    if ("Seg1".equals(parameterName)) return this.fSeg1;
    return null;
    
  }
  
  public Segment getSeg1() {
    return this.fSeg1;
    
  }
  
  @Override
  public boolean set(final String parameterName, final Object newValue) {
    if (!isMutable()) throw new java.lang.UnsupportedOperationException();
    if ("Seg1".equals(parameterName) ) {
    	this.fSeg1 = (Concept.Segment) newValue;
    	return true;
    }
    return false;
    
  }
  
  public void setSeg1(final Segment pSeg1) {
    if (!isMutable()) throw new java.lang.UnsupportedOperationException();
    this.fSeg1 = pSeg1;
    
  }
  
  @Override
  public String patternName() {
    return "hu.bme.mit.train.constraintcheck.incquery.ase_locals_3";
    
  }
  
  @Override
  public List<String> parameterNames() {
    return Ase_locals_3Match.parameterNames;
    
  }
  
  @Override
  public Object[] toArray() {
    return new Object[]{fSeg1};
    
  }
  
  @Override
  public String prettyPrint() {
    StringBuilder result = new StringBuilder();
    result.append("\"Seg1\"=" + prettyPrintValue(fSeg1));
    return result.toString();
    
  }
  
  @Override
  public int hashCode() {
    final int prime = 31;
    int result = 1;
    result = prime * result + ((fSeg1 == null) ? 0 : fSeg1.hashCode());
    return result;
    
  }
  
  @Override
  public boolean equals(final Object obj) {
    if (this == obj)
    	return true;
    if (!(obj instanceof Ase_locals_3Match)) { // this should be infrequent
    	if (obj == null)
    		return false;
    	if (!(obj instanceof IPatternMatch))
    		return false;
    	IPatternMatch otherSig  = (IPatternMatch) obj;
    	if (!specification().equals(otherSig.specification()))
    		return false;
    	return Arrays.deepEquals(toArray(), otherSig.toArray());
    }
    Ase_locals_3Match other = (Ase_locals_3Match) obj;
    if (fSeg1 == null) {if (other.fSeg1 != null) return false;}
    else if (!fSeg1.equals(other.fSeg1)) return false;
    return true;
  }
  
  @Override
  public Ase_locals_3QuerySpecification specification() {
    try {
    	return Ase_locals_3QuerySpecification.instance();
    } catch (IncQueryException ex) {
     	// This cannot happen, as the match object can only be instantiated if the query specification exists
     	throw new IllegalStateException	(ex);
    }
    
  }
  
  @SuppressWarnings("all")
  static final class Mutable extends Ase_locals_3Match {
    Mutable(final Segment pSeg1) {
      super(pSeg1);
      
    }
    
    @Override
    public boolean isMutable() {
      return true;
    }
  }
  
  
  @SuppressWarnings("all")
  static final class Immutable extends Ase_locals_3Match {
    Immutable(final Segment pSeg1) {
      super(pSeg1);
      
    }
    
    @Override
    public boolean isMutable() {
      return false;
    }
  }
  
}
