package hu.bme.mit.train.constraintcheck.incquery;

import hu.bme.mit.train.constraintcheck.incquery.Ase_param_1Matcher;
import hu.bme.mit.train.constraintcheck.incquery.Ase_param_1bMatcher;
import hu.bme.mit.train.constraintcheck.incquery.Ase_param_2Matcher;
import hu.bme.mit.train.constraintcheck.incquery.Ase_param_3Matcher;
import hu.bme.mit.train.constraintcheck.incquery.Ase_param_4Matcher;
import hu.bme.mit.train.constraintcheck.incquery.Ase_param_5Matcher;
import hu.bme.mit.train.constraintcheck.incquery.util.Ase_param_1QuerySpecification;
import hu.bme.mit.train.constraintcheck.incquery.util.Ase_param_1bQuerySpecification;
import hu.bme.mit.train.constraintcheck.incquery.util.Ase_param_2QuerySpecification;
import hu.bme.mit.train.constraintcheck.incquery.util.Ase_param_3QuerySpecification;
import hu.bme.mit.train.constraintcheck.incquery.util.Ase_param_4QuerySpecification;
import hu.bme.mit.train.constraintcheck.incquery.util.Ase_param_5QuerySpecification;
import org.eclipse.incquery.runtime.api.IncQueryEngine;
import org.eclipse.incquery.runtime.api.impl.BaseGeneratedPatternGroup;
import org.eclipse.incquery.runtime.exception.IncQueryException;

/**
 * A pattern group formed of all patterns defined in ase_numberOfParameters.eiq.
 * 
 * <p>Use the static instance as any {@link org.eclipse.incquery.runtime.api.IPatternGroup}, to conveniently prepare
 * an EMF-IncQuery engine for matching all patterns originally defined in file ase_numberOfParameters.eiq,
 * in order to achieve better performance than one-by-one on-demand matcher initialization.
 * 
 * <p> From package hu.bme.mit.train.constraintcheck.incquery, the group contains the definition of the following patterns: <ul>
 * <li>ase_param_1</li>
 * <li>ase_param_1b</li>
 * <li>ase_param_2</li>
 * <li>ase_param_3</li>
 * <li>ase_param_4</li>
 * <li>ase_param_5</li>
 * </ul>
 * 
 * @see IPatternGroup
 * 
 */
@SuppressWarnings("all")
public final class Ase_numberOfParameters extends BaseGeneratedPatternGroup {
  /**
   * Access the pattern group.
   * 
   * @return the singleton instance of the group
   * @throws IncQueryException if there was an error loading the generated code of pattern specifications
   * 
   */
  public static Ase_numberOfParameters instance() throws IncQueryException {
    if (INSTANCE == null) {
    	INSTANCE = new Ase_numberOfParameters();
    }
    return INSTANCE;
    
  }
  
  private static Ase_numberOfParameters INSTANCE;
  
  private Ase_numberOfParameters() throws IncQueryException {
    querySpecifications.add(Ase_param_1QuerySpecification.instance());
    querySpecifications.add(Ase_param_1bQuerySpecification.instance());
    querySpecifications.add(Ase_param_2QuerySpecification.instance());
    querySpecifications.add(Ase_param_3QuerySpecification.instance());
    querySpecifications.add(Ase_param_4QuerySpecification.instance());
    querySpecifications.add(Ase_param_5QuerySpecification.instance());
    
  }
  
  public Ase_param_1QuerySpecification getAse_param_1() throws IncQueryException {
    return Ase_param_1QuerySpecification.instance();
  }
  
  public Ase_param_1Matcher getAse_param_1(final IncQueryEngine engine) throws IncQueryException {
    return Ase_param_1Matcher.on(engine);
  }
  
  public Ase_param_1bQuerySpecification getAse_param_1b() throws IncQueryException {
    return Ase_param_1bQuerySpecification.instance();
  }
  
  public Ase_param_1bMatcher getAse_param_1b(final IncQueryEngine engine) throws IncQueryException {
    return Ase_param_1bMatcher.on(engine);
  }
  
  public Ase_param_2QuerySpecification getAse_param_2() throws IncQueryException {
    return Ase_param_2QuerySpecification.instance();
  }
  
  public Ase_param_2Matcher getAse_param_2(final IncQueryEngine engine) throws IncQueryException {
    return Ase_param_2Matcher.on(engine);
  }
  
  public Ase_param_3QuerySpecification getAse_param_3() throws IncQueryException {
    return Ase_param_3QuerySpecification.instance();
  }
  
  public Ase_param_3Matcher getAse_param_3(final IncQueryEngine engine) throws IncQueryException {
    return Ase_param_3Matcher.on(engine);
  }
  
  public Ase_param_4QuerySpecification getAse_param_4() throws IncQueryException {
    return Ase_param_4QuerySpecification.instance();
  }
  
  public Ase_param_4Matcher getAse_param_4(final IncQueryEngine engine) throws IncQueryException {
    return Ase_param_4Matcher.on(engine);
  }
  
  public Ase_param_5QuerySpecification getAse_param_5() throws IncQueryException {
    return Ase_param_5QuerySpecification.instance();
  }
  
  public Ase_param_5Matcher getAse_param_5(final IncQueryEngine engine) throws IncQueryException {
    return Ase_param_5Matcher.on(engine);
  }
}
