package hu.bme.mit.train.constraintcheck.incquery;

import hu.bme.mit.train.constraintcheck.incquery.Ase_references_1Matcher;
import hu.bme.mit.train.constraintcheck.incquery.Ase_references_2Matcher;
import hu.bme.mit.train.constraintcheck.incquery.Ase_references_3Matcher;
import hu.bme.mit.train.constraintcheck.incquery.Ase_references_4Matcher;
import hu.bme.mit.train.constraintcheck.incquery.util.Ase_references_1QuerySpecification;
import hu.bme.mit.train.constraintcheck.incquery.util.Ase_references_2QuerySpecification;
import hu.bme.mit.train.constraintcheck.incquery.util.Ase_references_3QuerySpecification;
import hu.bme.mit.train.constraintcheck.incquery.util.Ase_references_4QuerySpecification;
import org.eclipse.incquery.runtime.api.IncQueryEngine;
import org.eclipse.incquery.runtime.api.impl.BaseGeneratedPatternGroup;
import org.eclipse.incquery.runtime.exception.IncQueryException;

/**
 * A pattern group formed of all patterns defined in ase_referenceCount.eiq.
 * 
 * <p>Use the static instance as any {@link org.eclipse.incquery.runtime.api.IPatternGroup}, to conveniently prepare
 * an EMF-IncQuery engine for matching all patterns originally defined in file ase_referenceCount.eiq,
 * in order to achieve better performance than one-by-one on-demand matcher initialization.
 * 
 * <p> From package hu.bme.mit.train.constraintcheck.incquery, the group contains the definition of the following patterns: <ul>
 * <li>ase_references_1</li>
 * <li>ase_references_2</li>
 * <li>ase_references_3</li>
 * <li>ase_references_4</li>
 * </ul>
 * 
 * @see IPatternGroup
 * 
 */
@SuppressWarnings("all")
public final class Ase_referenceCount extends BaseGeneratedPatternGroup {
  /**
   * Access the pattern group.
   * 
   * @return the singleton instance of the group
   * @throws IncQueryException if there was an error loading the generated code of pattern specifications
   * 
   */
  public static Ase_referenceCount instance() throws IncQueryException {
    if (INSTANCE == null) {
    	INSTANCE = new Ase_referenceCount();
    }
    return INSTANCE;
    
  }
  
  private static Ase_referenceCount INSTANCE;
  
  private Ase_referenceCount() throws IncQueryException {
    querySpecifications.add(Ase_references_1QuerySpecification.instance());
    querySpecifications.add(Ase_references_2QuerySpecification.instance());
    querySpecifications.add(Ase_references_3QuerySpecification.instance());
    querySpecifications.add(Ase_references_4QuerySpecification.instance());
    
  }
  
  public Ase_references_1QuerySpecification getAse_references_1() throws IncQueryException {
    return Ase_references_1QuerySpecification.instance();
  }
  
  public Ase_references_1Matcher getAse_references_1(final IncQueryEngine engine) throws IncQueryException {
    return Ase_references_1Matcher.on(engine);
  }
  
  public Ase_references_2QuerySpecification getAse_references_2() throws IncQueryException {
    return Ase_references_2QuerySpecification.instance();
  }
  
  public Ase_references_2Matcher getAse_references_2(final IncQueryEngine engine) throws IncQueryException {
    return Ase_references_2Matcher.on(engine);
  }
  
  public Ase_references_3QuerySpecification getAse_references_3() throws IncQueryException {
    return Ase_references_3QuerySpecification.instance();
  }
  
  public Ase_references_3Matcher getAse_references_3(final IncQueryEngine engine) throws IncQueryException {
    return Ase_references_3Matcher.on(engine);
  }
  
  public Ase_references_4QuerySpecification getAse_references_4() throws IncQueryException {
    return Ase_references_4QuerySpecification.instance();
  }
  
  public Ase_references_4Matcher getAse_references_4(final IncQueryEngine engine) throws IncQueryException {
    return Ase_references_4Matcher.on(engine);
  }
}
