package hu.bme.mit.train.constraintcheck.incquery.ocl2iq;

import hu.bme.mit.train.constraintcheck.incquery.ocl2iq.SignalNeighborMatcher;
import hu.bme.mit.train.constraintcheck.incquery.ocl2iq.SignalNeighbor_4Matcher;
import hu.bme.mit.train.constraintcheck.incquery.ocl2iq.util.SignalNeighborQuerySpecification;
import hu.bme.mit.train.constraintcheck.incquery.ocl2iq.util.SignalNeighbor_4QuerySpecification;
import org.eclipse.incquery.runtime.api.IncQueryEngine;
import org.eclipse.incquery.runtime.api.impl.BaseGeneratedPatternGroup;
import org.eclipse.incquery.runtime.exception.IncQueryException;

/**
 * A pattern group formed of all patterns defined in signalNeighbor.eiq.
 * 
 * <p>Use the static instance as any {@link org.eclipse.incquery.runtime.api.IPatternGroup}, to conveniently prepare
 * an EMF-IncQuery engine for matching all patterns originally defined in file signalNeighbor.eiq,
 * in order to achieve better performance than one-by-one on-demand matcher initialization.
 * 
 * <p> From package hu.bme.mit.train.constraintcheck.incquery.ocl2iq, the group contains the definition of the following patterns: <ul>
 * <li>SignalNeighbor</li>
 * <li>SignalNeighbor_4</li>
 * </ul>
 * 
 * @see IPatternGroup
 * 
 */
@SuppressWarnings("all")
public final class SignalNeighbor extends BaseGeneratedPatternGroup {
  /**
   * Access the pattern group.
   * 
   * @return the singleton instance of the group
   * @throws IncQueryException if there was an error loading the generated code of pattern specifications
   * 
   */
  public static SignalNeighbor instance() throws IncQueryException {
    if (INSTANCE == null) {
    	INSTANCE = new SignalNeighbor();
    }
    return INSTANCE;
    
  }
  
  private static SignalNeighbor INSTANCE;
  
  private SignalNeighbor() throws IncQueryException {
    querySpecifications.add(SignalNeighborQuerySpecification.instance());
    querySpecifications.add(SignalNeighbor_4QuerySpecification.instance());
    
  }
  
  public SignalNeighborQuerySpecification getSignalNeighbor() throws IncQueryException {
    return SignalNeighborQuerySpecification.instance();
  }
  
  public SignalNeighborMatcher getSignalNeighbor(final IncQueryEngine engine) throws IncQueryException {
    return SignalNeighborMatcher.on(engine);
  }
  
  public SignalNeighbor_4QuerySpecification getSignalNeighbor_4() throws IncQueryException {
    return SignalNeighbor_4QuerySpecification.instance();
  }
  
  public SignalNeighbor_4Matcher getSignalNeighbor_4(final IncQueryEngine engine) throws IncQueryException {
    return SignalNeighbor_4Matcher.on(engine);
  }
}
