package hu.bme.mit.train.constraintcheck.incquery.ocl2iq;

import hu.bme.mit.train.constraintcheck.incquery.ocl2iq.SwitchSensorMatcher;
import hu.bme.mit.train.constraintcheck.incquery.ocl2iq.SwitchSensor_0Matcher;
import hu.bme.mit.train.constraintcheck.incquery.ocl2iq.util.SwitchSensorQuerySpecification;
import hu.bme.mit.train.constraintcheck.incquery.ocl2iq.util.SwitchSensor_0QuerySpecification;
import org.eclipse.incquery.runtime.api.IncQueryEngine;
import org.eclipse.incquery.runtime.api.impl.BaseGeneratedPatternGroup;
import org.eclipse.incquery.runtime.exception.IncQueryException;

/**
 * A pattern group formed of all patterns defined in switchSensor.eiq.
 * 
 * <p>Use the static instance as any {@link org.eclipse.incquery.runtime.api.IPatternGroup}, to conveniently prepare
 * an EMF-IncQuery engine for matching all patterns originally defined in file switchSensor.eiq,
 * in order to achieve better performance than one-by-one on-demand matcher initialization.
 * 
 * <p> From package hu.bme.mit.train.constraintcheck.incquery.ocl2iq, the group contains the definition of the following patterns: <ul>
 * <li>SwitchSensor</li>
 * <li>SwitchSensor_0</li>
 * </ul>
 * 
 * @see IPatternGroup
 * 
 */
@SuppressWarnings("all")
public final class SwitchSensor extends BaseGeneratedPatternGroup {
  /**
   * Access the pattern group.
   * 
   * @return the singleton instance of the group
   * @throws IncQueryException if there was an error loading the generated code of pattern specifications
   * 
   */
  public static SwitchSensor instance() throws IncQueryException {
    if (INSTANCE == null) {
    	INSTANCE = new SwitchSensor();
    }
    return INSTANCE;
    
  }
  
  private static SwitchSensor INSTANCE;
  
  private SwitchSensor() throws IncQueryException {
    querySpecifications.add(SwitchSensorQuerySpecification.instance());
    querySpecifications.add(SwitchSensor_0QuerySpecification.instance());
    
  }
  
  public SwitchSensorQuerySpecification getSwitchSensor() throws IncQueryException {
    return SwitchSensorQuerySpecification.instance();
  }
  
  public SwitchSensorMatcher getSwitchSensor(final IncQueryEngine engine) throws IncQueryException {
    return SwitchSensorMatcher.on(engine);
  }
  
  public SwitchSensor_0QuerySpecification getSwitchSensor_0() throws IncQueryException {
    return SwitchSensor_0QuerySpecification.instance();
  }
  
  public SwitchSensor_0Matcher getSwitchSensor_0(final IncQueryEngine engine) throws IncQueryException {
    return SwitchSensor_0Matcher.on(engine);
  }
}
