package hu.bme.mit.train.constraintcheck.incquery.util;

import com.google.common.collect.Sets;
import hu.bme.mit.train.constraintcheck.incquery.Ase_locals_3Matcher;
import java.util.Arrays;
import java.util.List;
import java.util.Set;
import org.eclipse.incquery.runtime.api.IncQueryEngine;
import org.eclipse.incquery.runtime.api.impl.BaseGeneratedQuerySpecification;
import org.eclipse.incquery.runtime.context.EMFPatternMatcherContext;
import org.eclipse.incquery.runtime.exception.IncQueryException;
import org.eclipse.incquery.runtime.extensibility.IQuerySpecificationProvider;
import org.eclipse.incquery.runtime.matchers.psystem.PBody;
import org.eclipse.incquery.runtime.matchers.psystem.PParameter;
import org.eclipse.incquery.runtime.matchers.psystem.PQuery;
import org.eclipse.incquery.runtime.matchers.psystem.PVariable;
import org.eclipse.incquery.runtime.matchers.psystem.basicdeferred.ExportedParameter;
import org.eclipse.incquery.runtime.matchers.psystem.basicenumerables.TypeBinary;
import org.eclipse.incquery.runtime.matchers.psystem.basicenumerables.TypeUnary;

/**
 * A pattern-specific query specification that can instantiate Ase_locals_3Matcher in a type-safe way.
 * 
 * @see Ase_locals_3Matcher
 * @see Ase_locals_3Match
 * 
 */
@SuppressWarnings("all")
public final class Ase_locals_3QuerySpecification extends BaseGeneratedQuerySpecification<Ase_locals_3Matcher> {
  /**
   * @return the singleton instance of the query specification
   * @throws IncQueryException if the pattern definition could not be loaded
   * 
   */
  public static Ase_locals_3QuerySpecification instance() throws IncQueryException {
    try {
    	return LazyHolder.INSTANCE;
    } catch (ExceptionInInitializerError err) {
    	processInitializerError(err);
    	throw err;
    }
    
  }
  
  @Override
  protected Ase_locals_3Matcher instantiate(final IncQueryEngine engine) throws IncQueryException {
    return Ase_locals_3Matcher.on(engine);
  }
  
  @Override
  public String getFullyQualifiedName() {
    return "hu.bme.mit.train.constraintcheck.incquery.ase_locals_3";
    
  }
  
  @Override
  public List<String> getParameterNames() {
    return Arrays.asList("Seg1");
  }
  
  @Override
  public List<PParameter> getParameters() {
    return Arrays.asList(new PParameter("Seg1", "Concept.Segment"));
  }
  
  @Override
  public Set<PBody> doGetContainedBodies() throws IncQueryException {
    EMFPatternMatcherContext context = new EMFPatternMatcherContext();
    Set<PBody> bodies = Sets.newHashSet();
    {
      PBody body = new PBody(this);
      PVariable var_Seg1 = body.getOrCreateVariableByName("Seg1");
      PVariable var_Seg2 = body.getOrCreateVariableByName("Seg2");
      PVariable var_Seg3 = body.getOrCreateVariableByName("Seg3");
      body.setExportedParameters(Arrays.asList(
        new ExportedParameter(body, var_Seg1, "Seg1")
      ));
      
      new TypeUnary(body, var_Seg2, getClassifierLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Segment"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Segment");
      new TypeBinary(body, context, var_Seg1, var_Seg2, getFeatureLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Trackelement", "TrackElement_connectsTo"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Trackelement.TrackElement_connectsTo");
      new TypeBinary(body, context, var_Seg2, var_Seg3, getFeatureLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Trackelement", "TrackElement_connectsTo"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Trackelement.TrackElement_connectsTo");
      new TypeUnary(body, var_Seg3, getClassifierLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Segment"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Segment");
      new TypeBinary(body, context, var_Seg3, var_Seg1, getFeatureLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Trackelement", "TrackElement_connectsTo"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Trackelement.TrackElement_connectsTo");
      new TypeBinary(body, context, var_Seg2, var_Seg1, getFeatureLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Trackelement", "TrackElement_connectsTo"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Trackelement.TrackElement_connectsTo");
      new TypeBinary(body, context, var_Seg3, var_Seg2, getFeatureLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Trackelement", "TrackElement_connectsTo"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Trackelement.TrackElement_connectsTo");
      new TypeUnary(body, var_Seg1, getClassifierLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Segment"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Segment");
      new TypeBinary(body, context, var_Seg1, var_Seg3, getFeatureLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Trackelement", "TrackElement_connectsTo"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Trackelement.TrackElement_connectsTo");
      bodies.add(body);
    }setStatus(PQuery.PQueryStatus.OK);
    return bodies;
  }
  
  private Ase_locals_3QuerySpecification() throws IncQueryException {
    super();
    setStatus(PQuery.PQueryStatus.UNINITIALIZED);
  }
  
  @SuppressWarnings("all")
  public static class Provider implements IQuerySpecificationProvider<Ase_locals_3QuerySpecification> {
    @Override
    public Ase_locals_3QuerySpecification get() throws IncQueryException {
      return instance();
    }
  }
  
  
  @SuppressWarnings("all")
  private static class LazyHolder {
    private final static Ase_locals_3QuerySpecification INSTANCE = make();
    
    public static Ase_locals_3QuerySpecification make() {
      try {
      	return new Ase_locals_3QuerySpecification();
      } catch (IncQueryException ex) {
      	throw new RuntimeException	(ex);
      }
      
    }
  }
  
}
