package hu.bme.mit.train.constraintcheck.incquery.util;

import com.google.common.collect.Sets;
import hu.bme.mit.train.constraintcheck.incquery.Ase_neg_5Matcher;
import hu.bme.mit.train.constraintcheck.incquery.util.Ase_neg_4QuerySpecification;
import java.util.Arrays;
import java.util.List;
import java.util.Set;
import org.eclipse.incquery.runtime.api.IncQueryEngine;
import org.eclipse.incquery.runtime.api.impl.BaseGeneratedQuerySpecification;
import org.eclipse.incquery.runtime.context.EMFPatternMatcherContext;
import org.eclipse.incquery.runtime.exception.IncQueryException;
import org.eclipse.incquery.runtime.extensibility.IQuerySpecificationProvider;
import org.eclipse.incquery.runtime.matchers.psystem.PBody;
import org.eclipse.incquery.runtime.matchers.psystem.PParameter;
import org.eclipse.incquery.runtime.matchers.psystem.PQuery;
import org.eclipse.incquery.runtime.matchers.psystem.PVariable;
import org.eclipse.incquery.runtime.matchers.psystem.basicdeferred.ExportedParameter;
import org.eclipse.incquery.runtime.matchers.psystem.basicdeferred.NegativePatternCall;
import org.eclipse.incquery.runtime.matchers.psystem.basicenumerables.TypeBinary;
import org.eclipse.incquery.runtime.matchers.psystem.basicenumerables.TypeUnary;
import org.eclipse.incquery.runtime.matchers.tuple.FlatTuple;

/**
 * A pattern-specific query specification that can instantiate Ase_neg_5Matcher in a type-safe way.
 * 
 * @see Ase_neg_5Matcher
 * @see Ase_neg_5Match
 * 
 */
@SuppressWarnings("all")
public final class Ase_neg_5QuerySpecification extends BaseGeneratedQuerySpecification<Ase_neg_5Matcher> {
  /**
   * @return the singleton instance of the query specification
   * @throws IncQueryException if the pattern definition could not be loaded
   * 
   */
  public static Ase_neg_5QuerySpecification instance() throws IncQueryException {
    try {
    	return LazyHolder.INSTANCE;
    } catch (ExceptionInInitializerError err) {
    	processInitializerError(err);
    	throw err;
    }
    
  }
  
  @Override
  protected Ase_neg_5Matcher instantiate(final IncQueryEngine engine) throws IncQueryException {
    return Ase_neg_5Matcher.on(engine);
  }
  
  @Override
  public String getFullyQualifiedName() {
    return "hu.bme.mit.train.constraintcheck.incquery.ase_neg_5";
    
  }
  
  @Override
  public List<String> getParameterNames() {
    return Arrays.asList("Seg");
  }
  
  @Override
  public List<PParameter> getParameters() {
    return Arrays.asList(new PParameter("Seg", "Concept.Segment"));
  }
  
  @Override
  public Set<PBody> doGetContainedBodies() throws IncQueryException {
    EMFPatternMatcherContext context = new EMFPatternMatcherContext();
    Set<PBody> bodies = Sets.newHashSet();
    {
      PBody body = new PBody(this);
      PVariable var_Seg = body.getOrCreateVariableByName("Seg");
      PVariable var_Seg2 = body.getOrCreateVariableByName("Seg2");
      body.setExportedParameters(Arrays.asList(
        new ExportedParameter(body, var_Seg, "Seg")
      ));
      
      new TypeUnary(body, var_Seg, getClassifierLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Segment"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Segment");
      new TypeUnary(body, var_Seg2, getClassifierLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Segment"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Segment");
      new TypeBinary(body, context, var_Seg, var_Seg2, getFeatureLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Trackelement", "TrackElement_connectsTo"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Trackelement.TrackElement_connectsTo");
      new NegativePatternCall(body, new FlatTuple(var_Seg2), Ase_neg_4QuerySpecification.instance().instance());
      bodies.add(body);
    }setStatus(PQuery.PQueryStatus.OK);
    return bodies;
  }
  
  private Ase_neg_5QuerySpecification() throws IncQueryException {
    super();
    setStatus(PQuery.PQueryStatus.UNINITIALIZED);
  }
  
  @SuppressWarnings("all")
  public static class Provider implements IQuerySpecificationProvider<Ase_neg_5QuerySpecification> {
    @Override
    public Ase_neg_5QuerySpecification get() throws IncQueryException {
      return instance();
    }
  }
  
  
  @SuppressWarnings("all")
  private static class LazyHolder {
    private final static Ase_neg_5QuerySpecification INSTANCE = make();
    
    public static Ase_neg_5QuerySpecification make() {
      try {
      	return new Ase_neg_5QuerySpecification();
      } catch (IncQueryException ex) {
      	throw new RuntimeException	(ex);
      }
      
    }
  }
  
}
