package hu.bme.mit.train.constraintcheck.incquery.util;

import Concept.Route;
import hu.bme.mit.train.constraintcheck.incquery.Ase_param_1Match;
import org.eclipse.incquery.runtime.api.IMatchProcessor;

/**
 * A match processor tailored for the hu.bme.mit.train.constraintcheck.incquery.ase_param_1 pattern.
 * 
 * Clients should derive an (anonymous) class that implements the abstract process().
 * 
 */
@SuppressWarnings("all")
public abstract class Ase_param_1Processor implements IMatchProcessor<Ase_param_1Match> {
  /**
   * Defines the action that is to be executed on each match.
   * @param pR the value of pattern parameter R in the currently processed match
   * 
   */
  public abstract void process(final Route pR);
  
  @Override
  public void process(final Ase_param_1Match match) {
    process(match.getR());
    
  }
}
