package hu.bme.mit.train.constraintcheck.incquery.util;

import Concept.Route;
import Concept.Signal;
import hu.bme.mit.train.constraintcheck.incquery.Ase_param_2Match;
import org.eclipse.incquery.runtime.api.IMatchProcessor;

/**
 * A match processor tailored for the hu.bme.mit.train.constraintcheck.incquery.ase_param_2 pattern.
 * 
 * Clients should derive an (anonymous) class that implements the abstract process().
 * 
 */
@SuppressWarnings("all")
public abstract class Ase_param_2Processor implements IMatchProcessor<Ase_param_2Match> {
  /**
   * Defines the action that is to be executed on each match.
   * @param pR the value of pattern parameter R in the currently processed match
   * @param pSigA the value of pattern parameter SigA in the currently processed match
   * 
   */
  public abstract void process(final Route pR, final Signal pSigA);
  
  @Override
  public void process(final Ase_param_2Match match) {
    process(match.getR(), match.getSigA());
    
  }
}
