package hu.bme.mit.train.constraintcheck.incquery.util;

import Concept.Route;
import Concept.Sensor;
import Concept.Signal;
import Concept.Trackelement;
import hu.bme.mit.train.constraintcheck.incquery.Ase_paramb_4Match;
import org.eclipse.incquery.runtime.api.IMatchProcessor;

/**
 * A match processor tailored for the hu.bme.mit.train.constraintcheck.incquery.ase_paramb_4 pattern.
 * 
 * Clients should derive an (anonymous) class that implements the abstract process().
 * 
 */
@SuppressWarnings("all")
public abstract class Ase_paramb_4Processor implements IMatchProcessor<Ase_paramb_4Match> {
  /**
   * Defines the action that is to be executed on each match.
   * @param pR the value of pattern parameter R in the currently processed match
   * @param pSigA the value of pattern parameter SigA in the currently processed match
   * @param pTe1 the value of pattern parameter Te1 in the currently processed match
   * @param pSen1 the value of pattern parameter Sen1 in the currently processed match
   * 
   */
  public abstract void process(final Route pR, final Signal pSigA, final Trackelement pTe1, final Sensor pSen1);
  
  @Override
  public void process(final Ase_paramb_4Match match) {
    process(match.getR(), match.getSigA(), match.getTe1(), match.getSen1());
    
  }
}
