package hu.bme.mit.train.cc.nativ;

import hu.bme.mit.train.util.BenchmarkConfig;

import org.eclipse.incquery.runtime.rete.util.Options;
import org.eclipse.incquery.runtime.rete.util.Options.FunctionalDependencyOption;
import org.eclipse.incquery.runtime.rete.util.Options.PlanTrimOption;

public class IncQueryCommon {
	public static void setEIQOptions(BenchmarkConfig bc) {
		if (bc.getFunctionalDependencyOption() != null) {
			if ("OFF".equals(bc.getFunctionalDependencyOption()))
				Options.functionalDependencyOption = FunctionalDependencyOption.OFF;
			else if ("OPPORTUNISTIC".equals(bc.getFunctionalDependencyOption()))
				Options.functionalDependencyOption = FunctionalDependencyOption.OPPORTUNISTIC;
		}
		if (bc.getStubTrimOption() != null) {
			if ("OFF".equals(bc.getStubTrimOption()))
				Options.planTrimOption = PlanTrimOption.OFF;
			else if ("OPPORTUNISTIC".equals(bc.getStubTrimOption()))
				Options.planTrimOption = PlanTrimOption.OPPORTUNISTIC;
		}

	}
}
