package hu.bme.mit.train.scenarios;

public class ScenarioFactory {

	public static ScenarioLogic getScenarioLogic(String scenario) {
		if ("UserScenario".equals(scenario))
			return getUserScenario();
		else if ("ModelXFormScenario".equals(scenario))
			return getModelXFormScenario();
		return null;
	}
	
	public static UserScenario getUserScenario() {
		return new UserScenario();
	}
	
	public static ModelXFormScenario getModelXFormScenario() {
		return new ModelXFormScenario();
	}
}
