package hu.bme.mit.train.common;

public class RuntimeConstants {
	// You must change this:
	public static String workspacePath = "D:\\WORKlipse\\runtime-Workspace";
	
	// these are maybe correct, but you should check
	public static final String projectPath = workspacePath + "/hu.bme.mit.Train.constraintCheck";
	public static final String modelProjectPath = workspacePath + "/hu.bme.mit.Train.InstanceModels";
	public static final String modelProjectPLUGIN_ID = "hu.bme.mit.Train.InstanceModels";
	
	// EMF instance model variant
	// ""    -- for default EMF instance model
	// "P"   -- for Praxis, that needs uuid generated instance model
	// "PUs" -- uuid + UltraSlim diet
	// "B"   -- BinaryResourceFactory
	public static final String emfVariant = "";

	// give NOPASSWD sudo to this script to clear the file cache
	public static final String clearCacheCommand = projectPath + "/scripts/clearCache.sh";

	// RacerPro settings
	public static String racerProFile = workspacePath + "/hu.bme.mit.Train.constraintCheck.racer/binary/racerpro-20-preview/RacerPro";
	public static final String racerProPort = "8088";
	
	// Sher settings
	public static final String SHER_HOME = workspacePath + "/hu.bme.mit.Train.constraintCheck.sher/binary/sher";
	
	// Virtuoso settings
	public static final String VIRTUOSO_HOME = workspacePath + "/hu.bme.mit.Train.constraintCheck.virtuoso/binary/virtuoso";

	public static final boolean standAlone = true;
}
