package hu.bme.mit.train.constraintcheck.incquery;

import Concept.Segment;
import hu.bme.mit.train.constraintcheck.incquery.util.Ase_neg_2QuerySpecification;
import java.util.Arrays;
import java.util.List;
import org.eclipse.incquery.runtime.api.IPatternMatch;
import org.eclipse.incquery.runtime.api.impl.BasePatternMatch;
import org.eclipse.incquery.runtime.exception.IncQueryException;

/**
 * Pattern-specific match representation of the hu.bme.mit.train.constraintcheck.incquery.ase_neg_2 pattern,
 * to be used in conjunction with {@link Ase_neg_2Matcher}.
 * 
 * <p>Class fields correspond to parameters of the pattern. Fields with value null are considered unassigned.
 * Each instance is a (possibly partial) substitution of pattern parameters,
 * usable to represent a match of the pattern in the result of a query,
 * or to specify the bound (fixed) input parameters when issuing a query.
 * 
 * @see Ase_neg_2Matcher
 * @see Ase_neg_2Processor
 * 
 */
@SuppressWarnings("all")
public abstract class Ase_neg_2Match extends BasePatternMatch {
  private Segment fSeg;
  
  private static List<String> parameterNames = makeImmutableList("Seg");
  
  private Ase_neg_2Match(final Segment pSeg) {
    this.fSeg = pSeg;
    
  }
  
  @Override
  public Object get(final String parameterName) {
    if ("Seg".equals(parameterName)) return this.fSeg;
    return null;
    
  }
  
  public Segment getSeg() {
    return this.fSeg;
    
  }
  
  @Override
  public boolean set(final String parameterName, final Object newValue) {
    if (!isMutable()) throw new java.lang.UnsupportedOperationException();
    if ("Seg".equals(parameterName) ) {
    	this.fSeg = (Concept.Segment) newValue;
    	return true;
    }
    return false;
    
  }
  
  public void setSeg(final Segment pSeg) {
    if (!isMutable()) throw new java.lang.UnsupportedOperationException();
    this.fSeg = pSeg;
    
  }
  
  @Override
  public String patternName() {
    return "hu.bme.mit.train.constraintcheck.incquery.ase_neg_2";
    
  }
  
  @Override
  public List<String> parameterNames() {
    return Ase_neg_2Match.parameterNames;
    
  }
  
  @Override
  public Object[] toArray() {
    return new Object[]{fSeg};
    
  }
  
  @Override
  public String prettyPrint() {
    StringBuilder result = new StringBuilder();
    result.append("\"Seg\"=" + prettyPrintValue(fSeg));
    return result.toString();
    
  }
  
  @Override
  public int hashCode() {
    final int prime = 31;
    int result = 1;
    result = prime * result + ((fSeg == null) ? 0 : fSeg.hashCode());
    return result;
    
  }
  
  @Override
  public boolean equals(final Object obj) {
    if (this == obj)
    	return true;
    if (!(obj instanceof Ase_neg_2Match)) { // this should be infrequent
    	if (obj == null)
    		return false;
    	if (!(obj instanceof IPatternMatch))
    		return false;
    	IPatternMatch otherSig  = (IPatternMatch) obj;
    	if (!specification().equals(otherSig.specification()))
    		return false;
    	return Arrays.deepEquals(toArray(), otherSig.toArray());
    }
    Ase_neg_2Match other = (Ase_neg_2Match) obj;
    if (fSeg == null) {if (other.fSeg != null) return false;}
    else if (!fSeg.equals(other.fSeg)) return false;
    return true;
  }
  
  @Override
  public Ase_neg_2QuerySpecification specification() {
    try {
    	return Ase_neg_2QuerySpecification.instance();
    } catch (IncQueryException ex) {
     	// This cannot happen, as the match object can only be instantiated if the query specification exists
     	throw new IllegalStateException	(ex);
    }
    
  }
  
  @SuppressWarnings("all")
  static final class Mutable extends Ase_neg_2Match {
    Mutable(final Segment pSeg) {
      super(pSeg);
      
    }
    
    @Override
    public boolean isMutable() {
      return true;
    }
  }
  
  
  @SuppressWarnings("all")
  static final class Immutable extends Ase_neg_2Match {
    Immutable(final Segment pSeg) {
      super(pSeg);
      
    }
    
    @Override
    public boolean isMutable() {
      return false;
    }
  }
  
}
