package hu.bme.mit.train.constraintcheck.incquery;

import Concept.Segment;
import hu.bme.mit.train.constraintcheck.incquery.Ase_neg_3Match;
import hu.bme.mit.train.constraintcheck.incquery.util.Ase_neg_3QuerySpecification;
import java.util.Collection;
import java.util.HashSet;
import java.util.Set;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.incquery.runtime.api.IMatchProcessor;
import org.eclipse.incquery.runtime.api.IQuerySpecification;
import org.eclipse.incquery.runtime.api.IncQueryEngine;
import org.eclipse.incquery.runtime.api.impl.BaseMatcher;
import org.eclipse.incquery.runtime.exception.IncQueryException;
import org.eclipse.incquery.runtime.matchers.tuple.Tuple;
import org.eclipse.incquery.runtime.rete.misc.DeltaMonitor;

/**
 * Generated pattern matcher API of the hu.bme.mit.train.constraintcheck.incquery.ase_neg_3 pattern,
 * providing pattern-specific query methods.
 * 
 * <p>Use the pattern matcher on a given model via {@link #on(IncQueryEngine)},
 * e.g. in conjunction with {@link IncQueryEngine#on(Notifier)}.
 * 
 * <p>Matches of the pattern will be represented as {@link Ase_neg_3Match}.
 * 
 * <p>Original source:
 * <code><pre>
 * pattern ase_neg_3(Seg) =
 * {
 * 	Segment(Seg);
 * 	Segment(Seg2);
 * 	Segment.TrackElement_connectsTo(Seg, Seg2);
 * 	neg find ase_neg_2(Seg2);
 * }
 * </pre></code>
 * 
 * @see Ase_neg_3Match
 * @see Ase_neg_3Processor
 * @see Ase_neg_3QuerySpecification
 * 
 */
@SuppressWarnings("all")
public class Ase_neg_3Matcher extends BaseMatcher<Ase_neg_3Match> {
  /**
   * @return the singleton instance of the query specification of this pattern
   * @throws IncQueryException if the pattern definition could not be loaded
   * 
   */
  public static IQuerySpecification<Ase_neg_3Matcher> querySpecification() throws IncQueryException {
    return Ase_neg_3QuerySpecification.instance();
  }
  
  /**
   * Initializes the pattern matcher within an existing EMF-IncQuery engine.
   * If the pattern matcher is already constructed in the engine, only a light-weight reference is returned.
   * The match set will be incrementally refreshed upon updates.
   * @param engine the existing EMF-IncQuery engine in which this matcher will be created.
   * @throws IncQueryException if an error occurs during pattern matcher creation
   * 
   */
  public static Ase_neg_3Matcher on(final IncQueryEngine engine) throws IncQueryException {
    // check if matcher already exists
    Ase_neg_3Matcher matcher = engine.getExistingMatcher(querySpecification());
    if (matcher == null) {
    	matcher = new Ase_neg_3Matcher(engine);
    	// do not have to "put" it into engine.matchers, reportMatcherInitialized() will take care of it
    }
    return matcher;
  }
  
  private final static int POSITION_SEG = 0;
  
  /**
   * Initializes the pattern matcher over a given EMF model root (recommended: Resource or ResourceSet).
   * If a pattern matcher is already constructed with the same root, only a light-weight reference is returned.
   * The scope of pattern matching will be the given EMF model root and below (see FAQ for more precise definition).
   * The match set will be incrementally refreshed upon updates from this scope.
   * <p>The matcher will be created within the managed {@link IncQueryEngine} belonging to the EMF model root, so
   * multiple matchers will reuse the same engine and benefit from increased performance and reduced memory footprint.
   * @param emfRoot the root of the EMF containment hierarchy where the pattern matcher will operate. Recommended: Resource or ResourceSet.
   * @throws IncQueryException if an error occurs during pattern matcher creation
   * @deprecated use {@link #on(IncQueryEngine)} instead, e.g. in conjunction with {@link IncQueryEngine#on(Notifier)}
   * 
   */
  @Deprecated
  public Ase_neg_3Matcher(final Notifier emfRoot) throws IncQueryException {
    this(IncQueryEngine.on(emfRoot));
  }
  
  /**
   * Initializes the pattern matcher within an existing EMF-IncQuery engine.
   * If the pattern matcher is already constructed in the engine, only a light-weight reference is returned.
   * The match set will be incrementally refreshed upon updates.
   * @param engine the existing EMF-IncQuery engine in which this matcher will be created.
   * @throws IncQueryException if an error occurs during pattern matcher creation
   * @deprecated use {@link #on(IncQueryEngine)} instead
   * 
   */
  @Deprecated
  public Ase_neg_3Matcher(final IncQueryEngine engine) throws IncQueryException {
    super(engine, querySpecification());
  }
  
  /**
   * Returns the set of all matches of the pattern that conform to the given fixed values of some parameters.
   * @param pSeg the fixed value of pattern parameter Seg, or null if not bound.
   * @return matches represented as a Ase_neg_3Match object.
   * 
   */
  public Collection<Ase_neg_3Match> getAllMatches(final Segment pSeg) {
    return rawGetAllMatches(new Object[]{pSeg});
  }
  
  /**
   * Returns an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters.
   * Neither determinism nor randomness of selection is guaranteed.
   * @param pSeg the fixed value of pattern parameter Seg, or null if not bound.
   * @return a match represented as a Ase_neg_3Match object, or null if no match is found.
   * 
   */
  public Ase_neg_3Match getOneArbitraryMatch(final Segment pSeg) {
    return rawGetOneArbitraryMatch(new Object[]{pSeg});
  }
  
  /**
   * Indicates whether the given combination of specified pattern parameters constitute a valid pattern match,
   * under any possible substitution of the unspecified parameters (if any).
   * @param pSeg the fixed value of pattern parameter Seg, or null if not bound.
   * @return true if the input is a valid (partial) match of the pattern.
   * 
   */
  public boolean hasMatch(final Segment pSeg) {
    return rawHasMatch(new Object[]{pSeg});
  }
  
  /**
   * Returns the number of all matches of the pattern that conform to the given fixed values of some parameters.
   * @param pSeg the fixed value of pattern parameter Seg, or null if not bound.
   * @return the number of pattern matches found.
   * 
   */
  public int countMatches(final Segment pSeg) {
    return rawCountMatches(new Object[]{pSeg});
  }
  
  /**
   * Executes the given processor on each match of the pattern that conforms to the given fixed values of some parameters.
   * @param pSeg the fixed value of pattern parameter Seg, or null if not bound.
   * @param processor the action that will process each pattern match.
   * 
   */
  public void forEachMatch(final Segment pSeg, final IMatchProcessor<? super Ase_neg_3Match> processor) {
    rawForEachMatch(new Object[]{pSeg}, processor);
  }
  
  /**
   * Executes the given processor on an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters.
   * Neither determinism nor randomness of selection is guaranteed.
   * @param pSeg the fixed value of pattern parameter Seg, or null if not bound.
   * @param processor the action that will process the selected match.
   * @return true if the pattern has at least one match with the given parameter values, false if the processor was not invoked
   * 
   */
  public boolean forOneArbitraryMatch(final Segment pSeg, final IMatchProcessor<? super Ase_neg_3Match> processor) {
    return rawForOneArbitraryMatch(new Object[]{pSeg}, processor);
  }
  
  /**
   * Registers a new filtered delta monitor on this pattern matcher.
   * The DeltaMonitor can be used to track changes (delta) in the set of filtered pattern matches from now on, considering those matches only that conform to the given fixed values of some parameters.
   * It can also be reset to track changes from a later point in time,
   * and changes can even be acknowledged on an individual basis.
   * See {@link DeltaMonitor} for details.
   * @param fillAtStart if true, all current matches are reported as new match events; if false, the delta monitor starts empty.
   * @param pSeg the fixed value of pattern parameter Seg, or null if not bound.
   * @return the delta monitor.
   * @deprecated use the IncQuery Databinding API (IncQueryObservables) instead.
   * 
   */
  @Deprecated
  public DeltaMonitor<Ase_neg_3Match> newFilteredDeltaMonitor(final boolean fillAtStart, final Segment pSeg) {
    return rawNewFilteredDeltaMonitor(fillAtStart, new Object[]{pSeg});
  }
  
  /**
   * Returns a new (partial) Match object for the matcher.
   * This can be used e.g. to call the matcher with a partial match.
   * <p>The returned match will be immutable. Use {@link #newEmptyMatch()} to obtain a mutable match object.
   * @param pSeg the fixed value of pattern parameter Seg, or null if not bound.
   * @return the (partial) match object.
   * 
   */
  public Ase_neg_3Match newMatch(final Segment pSeg) {
    return new Ase_neg_3Match.Immutable(pSeg);
    
  }
  
  /**
   * Retrieve the set of values that occur in matches for Seg.
   * @return the Set of all values, null if no parameter with the given name exists, empty set if there are no matches
   * 
   */
  protected Set<Segment> rawAccumulateAllValuesOfSeg(final Object[] parameters) {
    Set<Segment> results = new HashSet<Segment>();
    rawAccumulateAllValues(POSITION_SEG, parameters, results);
    return results;
  }
  
  /**
   * Retrieve the set of values that occur in matches for Seg.
   * @return the Set of all values, null if no parameter with the given name exists, empty set if there are no matches
   * 
   */
  public Set<Segment> getAllValuesOfSeg() {
    return rawAccumulateAllValuesOfSeg(emptyArray());
  }
  
  @Override
  protected Ase_neg_3Match tupleToMatch(final Tuple t) {
    try {
    	return new Ase_neg_3Match.Immutable((Concept.Segment) t.get(POSITION_SEG));
    } catch(ClassCastException e) {engine.getLogger().error("Element(s) in tuple not properly typed!",e);	//throw new IncQueryRuntimeException(e.getMessage());
    	return null;
    }
    
  }
  
  @Override
  protected Ase_neg_3Match arrayToMatch(final Object[] match) {
    try {
    	return new Ase_neg_3Match.Immutable((Concept.Segment) match[POSITION_SEG]);
    } catch(ClassCastException e) {engine.getLogger().error("Element(s) in array not properly typed!",e);	//throw new IncQueryRuntimeException(e.getMessage());
    	return null;
    }
    
  }
  
  @Override
  protected Ase_neg_3Match arrayToMatchMutable(final Object[] match) {
    try {
    	return new Ase_neg_3Match.Mutable((Concept.Segment) match[POSITION_SEG]);
    } catch(ClassCastException e) {engine.getLogger().error("Element(s) in array not properly typed!",e);	//throw new IncQueryRuntimeException(e.getMessage());
    	return null;
    }
    
  }
}
