package hu.bme.mit.train.constraintcheck.incquery;

import hu.bme.mit.train.constraintcheck.incquery.Ase_neg_1Matcher;
import hu.bme.mit.train.constraintcheck.incquery.Ase_neg_2Matcher;
import hu.bme.mit.train.constraintcheck.incquery.Ase_neg_3Matcher;
import hu.bme.mit.train.constraintcheck.incquery.Ase_neg_4Matcher;
import hu.bme.mit.train.constraintcheck.incquery.Ase_neg_5Matcher;
import hu.bme.mit.train.constraintcheck.incquery.util.Ase_neg_1QuerySpecification;
import hu.bme.mit.train.constraintcheck.incquery.util.Ase_neg_2QuerySpecification;
import hu.bme.mit.train.constraintcheck.incquery.util.Ase_neg_3QuerySpecification;
import hu.bme.mit.train.constraintcheck.incquery.util.Ase_neg_4QuerySpecification;
import hu.bme.mit.train.constraintcheck.incquery.util.Ase_neg_5QuerySpecification;
import org.eclipse.incquery.runtime.api.IncQueryEngine;
import org.eclipse.incquery.runtime.api.impl.BaseGeneratedPatternGroup;
import org.eclipse.incquery.runtime.exception.IncQueryException;

/**
 * A pattern group formed of all patterns defined in ase_nestedNacDepth.eiq.
 * 
 * <p>Use the static instance as any {@link org.eclipse.incquery.runtime.api.IPatternGroup}, to conveniently prepare
 * an EMF-IncQuery engine for matching all patterns originally defined in file ase_nestedNacDepth.eiq,
 * in order to achieve better performance than one-by-one on-demand matcher initialization.
 * 
 * <p> From package hu.bme.mit.train.constraintcheck.incquery, the group contains the definition of the following patterns: <ul>
 * <li>ase_neg_1</li>
 * <li>ase_neg_2</li>
 * <li>ase_neg_3</li>
 * <li>ase_neg_4</li>
 * <li>ase_neg_5</li>
 * </ul>
 * 
 * @see IPatternGroup
 * 
 */
@SuppressWarnings("all")
public final class Ase_nestedNacDepth extends BaseGeneratedPatternGroup {
  /**
   * Access the pattern group.
   * 
   * @return the singleton instance of the group
   * @throws IncQueryException if there was an error loading the generated code of pattern specifications
   * 
   */
  public static Ase_nestedNacDepth instance() throws IncQueryException {
    if (INSTANCE == null) {
    	INSTANCE = new Ase_nestedNacDepth();
    }
    return INSTANCE;
    
  }
  
  private static Ase_nestedNacDepth INSTANCE;
  
  private Ase_nestedNacDepth() throws IncQueryException {
    querySpecifications.add(Ase_neg_1QuerySpecification.instance());
    querySpecifications.add(Ase_neg_2QuerySpecification.instance());
    querySpecifications.add(Ase_neg_3QuerySpecification.instance());
    querySpecifications.add(Ase_neg_4QuerySpecification.instance());
    querySpecifications.add(Ase_neg_5QuerySpecification.instance());
    
  }
  
  public Ase_neg_1QuerySpecification getAse_neg_1() throws IncQueryException {
    return Ase_neg_1QuerySpecification.instance();
  }
  
  public Ase_neg_1Matcher getAse_neg_1(final IncQueryEngine engine) throws IncQueryException {
    return Ase_neg_1Matcher.on(engine);
  }
  
  public Ase_neg_2QuerySpecification getAse_neg_2() throws IncQueryException {
    return Ase_neg_2QuerySpecification.instance();
  }
  
  public Ase_neg_2Matcher getAse_neg_2(final IncQueryEngine engine) throws IncQueryException {
    return Ase_neg_2Matcher.on(engine);
  }
  
  public Ase_neg_3QuerySpecification getAse_neg_3() throws IncQueryException {
    return Ase_neg_3QuerySpecification.instance();
  }
  
  public Ase_neg_3Matcher getAse_neg_3(final IncQueryEngine engine) throws IncQueryException {
    return Ase_neg_3Matcher.on(engine);
  }
  
  public Ase_neg_4QuerySpecification getAse_neg_4() throws IncQueryException {
    return Ase_neg_4QuerySpecification.instance();
  }
  
  public Ase_neg_4Matcher getAse_neg_4(final IncQueryEngine engine) throws IncQueryException {
    return Ase_neg_4Matcher.on(engine);
  }
  
  public Ase_neg_5QuerySpecification getAse_neg_5() throws IncQueryException {
    return Ase_neg_5QuerySpecification.instance();
  }
  
  public Ase_neg_5Matcher getAse_neg_5(final IncQueryEngine engine) throws IncQueryException {
    return Ase_neg_5Matcher.on(engine);
  }
}
