package hu.bme.mit.train.constraintcheck.incquery;

import hu.bme.mit.train.constraintcheck.incquery.Ase_locals_3Matcher;
import hu.bme.mit.train.constraintcheck.incquery.Ase_locals_4Matcher;
import hu.bme.mit.train.constraintcheck.incquery.Ase_locals_5Matcher;
import hu.bme.mit.train.constraintcheck.incquery.Ase_locals_6Matcher;
import hu.bme.mit.train.constraintcheck.incquery.Ase_locals_7Matcher;
import hu.bme.mit.train.constraintcheck.incquery.util.Ase_locals_3QuerySpecification;
import hu.bme.mit.train.constraintcheck.incquery.util.Ase_locals_4QuerySpecification;
import hu.bme.mit.train.constraintcheck.incquery.util.Ase_locals_5QuerySpecification;
import hu.bme.mit.train.constraintcheck.incquery.util.Ase_locals_6QuerySpecification;
import hu.bme.mit.train.constraintcheck.incquery.util.Ase_locals_7QuerySpecification;
import org.eclipse.incquery.runtime.api.IncQueryEngine;
import org.eclipse.incquery.runtime.api.impl.BaseGeneratedPatternGroup;
import org.eclipse.incquery.runtime.exception.IncQueryException;

/**
 * A pattern group formed of all patterns defined in ase_numberOfLocalVariables.eiq.
 * 
 * <p>Use the static instance as any {@link org.eclipse.incquery.runtime.api.IPatternGroup}, to conveniently prepare
 * an EMF-IncQuery engine for matching all patterns originally defined in file ase_numberOfLocalVariables.eiq,
 * in order to achieve better performance than one-by-one on-demand matcher initialization.
 * 
 * <p> From package hu.bme.mit.train.constraintcheck.incquery, the group contains the definition of the following patterns: <ul>
 * <li>ase_locals_3</li>
 * <li>ase_locals_4</li>
 * <li>ase_locals_5</li>
 * <li>ase_locals_6</li>
 * <li>ase_locals_7</li>
 * </ul>
 * 
 * @see IPatternGroup
 * 
 */
@SuppressWarnings("all")
public final class Ase_numberOfLocalVariables extends BaseGeneratedPatternGroup {
  /**
   * Access the pattern group.
   * 
   * @return the singleton instance of the group
   * @throws IncQueryException if there was an error loading the generated code of pattern specifications
   * 
   */
  public static Ase_numberOfLocalVariables instance() throws IncQueryException {
    if (INSTANCE == null) {
    	INSTANCE = new Ase_numberOfLocalVariables();
    }
    return INSTANCE;
    
  }
  
  private static Ase_numberOfLocalVariables INSTANCE;
  
  private Ase_numberOfLocalVariables() throws IncQueryException {
    querySpecifications.add(Ase_locals_3QuerySpecification.instance());
    querySpecifications.add(Ase_locals_4QuerySpecification.instance());
    querySpecifications.add(Ase_locals_5QuerySpecification.instance());
    querySpecifications.add(Ase_locals_6QuerySpecification.instance());
    querySpecifications.add(Ase_locals_7QuerySpecification.instance());
    
  }
  
  public Ase_locals_3QuerySpecification getAse_locals_3() throws IncQueryException {
    return Ase_locals_3QuerySpecification.instance();
  }
  
  public Ase_locals_3Matcher getAse_locals_3(final IncQueryEngine engine) throws IncQueryException {
    return Ase_locals_3Matcher.on(engine);
  }
  
  public Ase_locals_4QuerySpecification getAse_locals_4() throws IncQueryException {
    return Ase_locals_4QuerySpecification.instance();
  }
  
  public Ase_locals_4Matcher getAse_locals_4(final IncQueryEngine engine) throws IncQueryException {
    return Ase_locals_4Matcher.on(engine);
  }
  
  public Ase_locals_5QuerySpecification getAse_locals_5() throws IncQueryException {
    return Ase_locals_5QuerySpecification.instance();
  }
  
  public Ase_locals_5Matcher getAse_locals_5(final IncQueryEngine engine) throws IncQueryException {
    return Ase_locals_5Matcher.on(engine);
  }
  
  public Ase_locals_6QuerySpecification getAse_locals_6() throws IncQueryException {
    return Ase_locals_6QuerySpecification.instance();
  }
  
  public Ase_locals_6Matcher getAse_locals_6(final IncQueryEngine engine) throws IncQueryException {
    return Ase_locals_6Matcher.on(engine);
  }
  
  public Ase_locals_7QuerySpecification getAse_locals_7() throws IncQueryException {
    return Ase_locals_7QuerySpecification.instance();
  }
  
  public Ase_locals_7Matcher getAse_locals_7(final IncQueryEngine engine) throws IncQueryException {
    return Ase_locals_7Matcher.on(engine);
  }
}
