package hu.bme.mit.train.constraintcheck.incquery.ocl2iq.util;

import Concept.Sensor;
import Concept.SwitchPosition;
import hu.bme.mit.train.constraintcheck.incquery.ocl2iq.RouteSensor_0Match;
import org.eclipse.incquery.runtime.api.IMatchProcessor;

/**
 * A match processor tailored for the hu.bme.mit.train.constraintcheck.incquery.ocl2iq.RouteSensor_0 pattern.
 * 
 * Clients should derive an (anonymous) class that implements the abstract process().
 * 
 */
@SuppressWarnings("all")
public abstract class RouteSensor_0Processor implements IMatchProcessor<RouteSensor_0Match> {
  /**
   * Defines the action that is to be executed on each match.
   * @param pSp the value of pattern parameter sp in the currently processed match
   * @param pSelf the value of pattern parameter self in the currently processed match
   * 
   */
  public abstract void process(final SwitchPosition pSp, final Sensor pSelf);
  
  @Override
  public void process(final RouteSensor_0Match match) {
    process(match.getSp(), match.getSelf());
    
  }
}
