package hu.bme.mit.train.constraintcheck.incquery.ocl2iq.util;

import Concept.Sensor;
import Concept.Switch;
import hu.bme.mit.train.constraintcheck.incquery.ocl2iq.SwitchSensor_0Match;
import org.eclipse.incquery.runtime.api.IMatchProcessor;

/**
 * A match processor tailored for the hu.bme.mit.train.constraintcheck.incquery.ocl2iq.SwitchSensor_0 pattern.
 * 
 * Clients should derive an (anonymous) class that implements the abstract process().
 * 
 */
@SuppressWarnings("all")
public abstract class SwitchSensor_0Processor implements IMatchProcessor<SwitchSensor_0Match> {
  /**
   * Defines the action that is to be executed on each match.
   * @param pSelf the value of pattern parameter self in the currently processed match
   * @param pSensor the value of pattern parameter sensor in the currently processed match
   * 
   */
  public abstract void process(final Switch pSelf, final Sensor pSensor);
  
  @Override
  public void process(final SwitchSensor_0Match match) {
    process(match.getSelf(), match.getSensor());
    
  }
}
