package hu.bme.mit.train.constraintcheck.incquery.util;

import Concept.Segment;
import hu.bme.mit.train.constraintcheck.incquery.Ase_locals_3Match;
import org.eclipse.incquery.runtime.api.IMatchProcessor;

/**
 * A match processor tailored for the hu.bme.mit.train.constraintcheck.incquery.ase_locals_3 pattern.
 * 
 * Clients should derive an (anonymous) class that implements the abstract process().
 * 
 */
@SuppressWarnings("all")
public abstract class Ase_locals_3Processor implements IMatchProcessor<Ase_locals_3Match> {
  /**
   * Defines the action that is to be executed on each match.
   * @param pSeg1 the value of pattern parameter Seg1 in the currently processed match
   * 
   */
  public abstract void process(final Segment pSeg1);
  
  @Override
  public void process(final Ase_locals_3Match match) {
    process(match.getSeg1());
    
  }
}
