package hu.bme.mit.train.constraintcheck.incquery.util;

import Concept.Segment;
import hu.bme.mit.train.constraintcheck.incquery.Ase_neg_2Match;
import org.eclipse.incquery.runtime.api.IMatchProcessor;

/**
 * A match processor tailored for the hu.bme.mit.train.constraintcheck.incquery.ase_neg_2 pattern.
 * 
 * Clients should derive an (anonymous) class that implements the abstract process().
 * 
 */
@SuppressWarnings("all")
public abstract class Ase_neg_2Processor implements IMatchProcessor<Ase_neg_2Match> {
  /**
   * Defines the action that is to be executed on each match.
   * @param pSeg the value of pattern parameter Seg in the currently processed match
   * 
   */
  public abstract void process(final Segment pSeg);
  
  @Override
  public void process(final Ase_neg_2Match match) {
    process(match.getSeg());
    
  }
}
