#!/bin/bash

# you must pass the first parameter and configure the workspacePath file
tool=$1
. ./workspacePath

mount -t tmpfs -o size=10g tmpfs /mnt/tmpfs
mkdir -p /mnt/tmpfs/trainBenchmark/

if [[ $tool == "Allegro" ]]; then
mkdir -p /mnt/tmpfs/trainBenchmark/agraph/
cp -ax ${workspacePath}/agraph/* /mnt/tmpfs/trainBenchmark/agraph
mount -o bind /mnt/tmpfs/trainBenchmark/agraph ${workspacePath}/agraph/
elif [[ $tool == "Virtuoso" ]]; then
mkdir -p /mnt/tmpfs/trainBenchmark/virtuoso/
cp -ax ${workspacePath}/hu.bme.mit.Train.constraintCheck.virtuoso/binary/virtuoso/* /mnt/tmpfs/trainBenchmark/virtuoso
mount -o bind /mnt/tmpfs/trainBenchmark/virtuoso ${workspacePath}/hu.bme.mit.Train.constraintCheck.virtuoso/binary/virtuoso/
elif [[ $tool == "Stardog" ]]; then
mkdir -p /mnt/tmpfs/trainBenchmark/stardog/
cp -ax ${workspacePath}/hu.bme.mit.Train.constraintCheck.stardog/binary/stardog/* /mnt/tmpfs/trainBenchmark/stardog/
mount -o bind /mnt/tmpfs/trainBenchmark/stardog/ ${workspacePath}/hu.bme.mit.Train.constraintCheck.stardog/binary/stardog/
elif [[ $tool == "racer" ]]; then
mkdir -p /mnt/tmpfs/trainBenchmark/racerpro-20-preview/
cp -ax ${workspacePath}/hu.bme.mit.Train.constraintCheck.racer/binary/racerpro-20-preview/* /mnt/tmpfs/trainBenchmark/racerpro-20-preview/
mount -o bind /mnt/tmpfs/trainBenchmark/racerpro-20-preview/ ${workspacePath}/hu.bme.mit.Train.constraintCheck.racer/binary/racerpro-20-preview/
elif [[ $tool == "Neo4j" ]]; then
mkdir -p /mnt/tmpfs/trainBenchmark/Neo4j/
#cp -ax ${workspacePath}/hu.bme.mit.Train.constraintCheck.neo4j/neo4j-db/* /mnt/tmpfs/trainBenchmark/Neo4j
mount -o bind /mnt/tmpfs/trainBenchmark/Neo4j ${workspacePath}/hu.bme.mit.Train.constraintCheck.neo4j/neo4j-db
elif [[ $tool == "FourStore" ]]; then
mkdir -p /mnt/tmpfs/trainBenchmark/4store/
mount -o bind /mnt/tmpfs/trainBenchmark/4store /var/lib/4store
fi

chown -R bence. /mnt/tmpfs/trainBenchmark/
