package hu.bme.mit.train.scenarios;

import java.util.Collection;

import hu.bme.mit.train.util.CcBenchmark;

public interface TestFactory {
	public CcBenchmark getPosLength();
	public CcBenchmark getRouteSensor();
	public CcBenchmark getSwitchSensor();
	public CcBenchmark getSwitchSet();
	public CcBenchmark getSignalNeighbor();
	public CcBenchmark getRouteSensorAI();
	public CcBenchmark getSwitchSetAI();

	public Collection<Object[]> getPosLengthModelsizes();
	public Collection<Object[]> getRouteSensorModelsizes();
	public Collection<Object[]> getSwitchSensorModelsizes();
	public Collection<Object[]> getSwitchSetModelsizes();
	public Collection<Object[]> getSignalNeighborModelsizes();
	public Collection<Object[]> getRouteSensorAIModelsizes();
	public Collection<Object[]> getSwitchSetAIModelsizes();
}
